
#include <stdio.h>

extern void dis_8086(FILE *, unsigned int, const unsigned char *,
		     const unsigned char *);

main(int argc, char *argv[])
{
  unsigned char buf[65536];
  int n, off;

  n = read(0, buf, sizeof buf);
  if (n == -1)
    {
      perror("read");
      return 2;
    }
  if (n == 0)
    return 0;

  off = (argc > 1) ? strtoul(argv[1], (char **)0, 16) : 0;
  dis_8086(stdout, off, buf + off, buf + n);
  return 0;
}
